# Generated by Django 3.0.4 on 2020-03-29 03:29

import bitfield.models
from django.db import migrations, models
import django.utils.timezone
import isc_common.fields.code_field
import isc_common.fields.name_field


class Migration(migrations.Migration):

    dependencies = [
        ('ckk', '0218_auto_20200326_1857'),
    ]

    operations = [
        migrations.CreateModel(
            name='Tmp_Item_operations_view',
            fields=[
                ('id', models.BigAutoField(primary_key=True, serialize=False, verbose_name='Идентификатор')),
                ('deleted_at', models.DateTimeField(blank=True, db_index=True, null=True, verbose_name='Дата мягкого удаления')),
                ('editing', models.BooleanField(default=True, verbose_name='Возможность редактирования')),
                ('deliting', models.BooleanField(default=True, verbose_name='Возможность удаления')),
                ('lastmodified', models.DateTimeField(db_index=True, default=django.utils.timezone.now, editable=False, verbose_name='Последнее обновление')),
                ('refs_id', models.BigIntegerField()),
                ('relevant', isc_common.fields.name_field.NameField(blank=True, null=True)),
                ('where_from', isc_common.fields.name_field.NameField(blank=True, null=True)),
                ('props', bitfield.models.BitField((('relevant', 'Актуальность'), ('from_cdw', 'Получено из чертежа'), ('from_spw', 'Получено из спецификации'), ('for_line', 'Строка спецификации'), ('from_pdf', 'Получено из бумажного архива'), ('man_input', 'Занесено вручную'), ('copied', 'Скопировано'), ('from_lotsman', 'Получено из Лоцмана')), db_index=True, default=1)),
                ('refs_props', bitfield.models.BitField((('relevant', 'Актуальность'), ('used', 'Используемость в технологической спецификации')), db_index=True, default=3)),
                ('version', models.PositiveIntegerField(blank=True, null=True)),
                ('qty_operations', models.PositiveIntegerField()),
                ('section', isc_common.fields.code_field.CodeField(blank=True, null=True)),
                ('isFolder', models.BooleanField()),
            ],
            options={
                'verbose_name': 'Товарная позиция',
                'db_table': 'ckk_tmp_item_operations_view',
                'managed': False,
            },
        ),
        migrations.CreateModel(
            name='Tmp_Item_refs',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('props', bitfield.models.BitField((('relevant', 'Актуальность'), ('used', 'Используемость в технологической спецификации')), db_index=True, default=3)),
            ],
            options={
                'verbose_name': 'Tmp_Item_refs',
                'db_table': 'ckk_tmp_item_refs',
                'managed': False,
            },
        ),
        migrations.CreateModel(
            name='Tmp_Item_view',
            fields=[
                ('id', models.BigAutoField(primary_key=True, serialize=False, verbose_name='Идентификатор')),
                ('deleted_at', models.DateTimeField(blank=True, db_index=True, null=True, verbose_name='Дата мягкого удаления')),
                ('editing', models.BooleanField(default=True, verbose_name='Возможность редактирования')),
                ('deliting', models.BooleanField(default=True, verbose_name='Возможность удаления')),
                ('lastmodified', models.DateTimeField(db_index=True, default=django.utils.timezone.now, editable=False, verbose_name='Последнее обновление')),
                ('refs_id', models.BigIntegerField()),
                ('isLotsman', models.BooleanField()),
                ('relevant', isc_common.fields.name_field.NameField(blank=True, null=True)),
                ('where_from', isc_common.fields.name_field.NameField(blank=True, null=True)),
                ('props', bitfield.models.BitField((('relevant', 'Актуальность'), ('from_cdw', 'Получено из чертежа'), ('from_spw', 'Получено из спецификации'), ('for_line', 'Строка спецификации'), ('from_pdf', 'Получено из бумажного архива'), ('man_input', 'Занесено вручную'), ('copied', 'Скопировано'), ('from_lotsman', 'Получено из Лоцмана')), db_index=True, default=1)),
                ('refs_props', bitfield.models.BitField((('relevant', 'Актуальность'), ('used', 'Используемость в технологической спецификации')), db_index=True, default=3)),
                ('version', models.PositiveIntegerField(blank=True, null=True)),
                ('section', isc_common.fields.code_field.CodeField(blank=True, null=True)),
                ('isFolder', models.BooleanField()),
            ],
            options={
                'verbose_name': 'Товарная позиция',
                'db_table': 'ckk_tmp_item_view',
                'managed': False,
            },
        ),
    ]
