# Generated by Django 3.0.8 on 2020-07-17 03:39

import bitfield.models
from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion
import django.utils.timezone
import isc_common.fields.related


class Migration(migrations.Migration):

    dependencies = [
        ('kd', '0146_auto_20200329_0329'),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('ckk', '0230_auto_20200708_1517'),
    ]

    operations = [
        migrations.CreateModel(
            name='Item_history',
            fields=[
                ('id', models.BigAutoField(primary_key=True, serialize=False, verbose_name='Идентификатор')),
                ('deleted_at', models.DateTimeField(blank=True, db_index=True, null=True, verbose_name='Дата мягкого удаления')),
                ('editing', models.BooleanField(default=True, verbose_name='Возможность редактирования')),
                ('deliting', models.BooleanField(default=True, verbose_name='Возможность удаления')),
                ('lastmodified', models.DateTimeField(db_index=True, default=django.utils.timezone.now, editable=False, verbose_name='Последнее обновление')),
                ('version', models.PositiveIntegerField(blank=True, null=True)),
                ('props', bitfield.models.BitField((('relevant', 'Актуальность'), ('from_cdw', 'Получено из чертежа'), ('from_spw', 'Получено из спецификации'), ('for_line', 'Строка спецификации'), ('from_pdf', 'Получено из бумажного архива'), ('man_input', 'Занесено вручную'), ('copied', 'Скопировано'), ('from_lotsman', 'Получено из Лоцмана'), ('confirmed', 'Подтвержден')), db_index=True, default=1)),
                ('lotsman_type_id', models.BigIntegerField(blank=True, null=True)),
                ('STMP_1', isc_common.fields.related.ForeignKeyProtect(blank=True, null=True, on_delete=django.db.models.deletion.PROTECT, related_name='Item_history_STMP_1', to='kd.Document_attributes')),
                ('STMP_2', isc_common.fields.related.ForeignKeyProtect(blank=True, null=True, on_delete=django.db.models.deletion.PROTECT, related_name='Item_history_STMP_2', to='kd.Document_attributes')),
                ('document', isc_common.fields.related.ForeignKeyProtect(blank=True, null=True, on_delete=django.db.models.deletion.PROTECT, to='kd.Documents')),
                ('hcreator', isc_common.fields.related.ForeignKeyProtect(on_delete=django.db.models.deletion.PROTECT, to=settings.AUTH_USER_MODEL)),
                ('item', isc_common.fields.related.ForeignKeyCascade(on_delete=django.db.models.deletion.CASCADE, to='ckk.Item')),
                ('lotsman_document', isc_common.fields.related.ForeignKeyProtect(blank=True, null=True, on_delete=django.db.models.deletion.PROTECT, to='kd.Lotsman_documents_hierarcy')),
            ],
            options={
                'verbose_name': 'История операций',
            },
        ),
    ]
