# Generated by Django 3.0.7 on 2020-06-17 18:39

import bitfield.models
import django.utils.timezone
from django.db import migrations, models

import isc_common.fields.code_field
import isc_common.fields.name_field


class Migration(migrations.Migration):

    dependencies = [
        ('planing', '0152_auto_20200617_1052'),
    ]

    operations = [
        migrations.CreateModel(
            name='Operation_item_view',
            fields=[
                ('id', models.BigAutoField(primary_key=True, serialize=False, verbose_name='Идентификатор')),
                ('deleted_at', models.DateTimeField(blank=True, db_index=True, null=True, verbose_name='Дата мягкого удаления')),
                ('editing', models.BooleanField(default=True, verbose_name='Возможность редактирования')),
                ('deliting', models.BooleanField(default=True, verbose_name='Возможность удаления')),
                ('lastmodified', models.DateTimeField(db_index=True, default=django.utils.timezone.now, editable=False, verbose_name='Последнее обновление')),
                ('props', bitfield.models.BitField((('inner_routing', 'Связь операций внутри товарной позиции'), ('outer_routing', 'Связь операций между товарными позициями'), ('product_order_routing', 'Связи в блоке задания на производство'), ('product_meking', 'Связи в блоке выпуска')), db_index=True, default=0)),
            ],
            options={
                'verbose_name': 'Ресерсы операций',
                'db_table': 'planing_operation_item_view',
                'managed': False,
            },
        ),
        migrations.CreateModel(
            name='Operation_level_view',
            fields=[
                ('id', models.BigAutoField(primary_key=True, serialize=False, verbose_name='Идентификатор')),
                ('deleted_at', models.DateTimeField(blank=True, db_index=True, null=True, verbose_name='Дата мягкого удаления')),
                ('editing', models.BooleanField(default=True, verbose_name='Возможность редактирования')),
                ('deliting', models.BooleanField(default=True, verbose_name='Возможность удаления')),
                ('lastmodified', models.DateTimeField(db_index=True, default=django.utils.timezone.now, editable=False, verbose_name='Последнее обновление')),
                ('opers_refs_props', models.BigIntegerField()),
                ('props', bitfield.models.BitField((('isProductionOrder', 'Уровень заказа на производство'),), db_index=True, default=0)),
            ],
            options={
                'verbose_name': 'Кросс-таблица',
                'db_table': 'planing_operation_level_view',
                'managed': False,
            },
        ),
        migrations.CreateModel(
            name='Operation_location_view',
            fields=[
                ('id', models.BigAutoField(primary_key=True, serialize=False, verbose_name='Идентификатор')),
                ('deleted_at', models.DateTimeField(blank=True, db_index=True, null=True, verbose_name='Дата мягкого удаления')),
                ('editing', models.BooleanField(default=True, verbose_name='Возможность редактирования')),
                ('deliting', models.BooleanField(default=True, verbose_name='Возможность удаления')),
                ('lastmodified', models.DateTimeField(db_index=True, default=django.utils.timezone.now, editable=False, verbose_name='Последнее обновление')),
                ('opers_refs_props', models.BigIntegerField()),
            ],
            options={
                'verbose_name': 'Кросс-таблица',
                'db_table': 'planing_operation_location_view',
                'managed': False,
            },
        ),
        migrations.CreateModel(
            name='Operations_rout_view',
            fields=[
                ('id', models.BigAutoField(primary_key=True, serialize=False, verbose_name='Идентификатор')),
                ('deleted_at', models.DateTimeField(blank=True, db_index=True, null=True, verbose_name='Дата мягкого удаления')),
                ('editing', models.BooleanField(default=True, verbose_name='Возможность редактирования')),
                ('deliting', models.BooleanField(default=True, verbose_name='Возможность удаления')),
                ('lastmodified', models.DateTimeField(db_index=True, default=django.utils.timezone.now, editable=False, verbose_name='Последнее обновление')),
                ('date', models.DateTimeField(default=None)),
                ('description', models.TextField(blank=True, null=True)),
                ('isFolder', models.BooleanField(default=None)),
                ('mark', isc_common.fields.code_field.CodeField(blank=True, null=True)),
                ('num', isc_common.fields.code_field.CodeField(blank=True, null=True)),
                ('item_STMP_1_value_str', isc_common.fields.name_field.NameField(blank=True, null=True)),
                ('item_TMP_2_value_str', isc_common.fields.name_field.NameField(blank=True, null=True)),
                ('level_id', models.BigIntegerField()),
                ('location_id', models.BigIntegerField()),
                ('resource_id', models.BigIntegerField()),
                ('launch_id', models.BigIntegerField()),
                ('production_operation_ed_izm_id', models.BigIntegerField(blank=True, null=True)),
                ('production_operation_num', models.PositiveIntegerField(blank=True, null=True)),
                ('production_operation_qty', models.DecimalField(blank=True, decimal_places=4, max_digits=19, null=True)),
                ('props', bitfield.models.BitField((('inner_routing', 'Связь операций внутри товарной позиции'), ('outer_routing', 'Связь операций между товарными позициями'), ('product_order_routing', 'Связи в блоке задания на производство'), ('product_meking', 'Связи в блоке выпуска')), db_index=True, default=0)),
            ],
            options={
                'verbose_name': 'Опреации системные',
                'db_table': 'planing_operation_rout_view',
                'managed': False,
            },
        ),
        migrations.AlterUniqueTogether(
            name='operation_resources',
            unique_together=set(),
        ),
    ]
