# Generated by Django 3.0.7 on 2020-07-02 16:19

import bitfield.models
import django.db.models
from django.contrib.postgres.fields import ArrayField
from django.db import migrations, models
import django.utils.timezone
import isc_common.fields.code_field


class Migration(migrations.Migration):

    dependencies = [
        ('planing', '0172_delete_production_order_by_launch'),
    ]

    operations = [
        migrations.CreateModel(
            name='Production_order_opers_per_launch',
            fields=[
                ('id', models.BigAutoField(primary_key=True, serialize=False, verbose_name='Идентификатор')),
                ('deleted_at', models.DateTimeField(blank=True, db_index=True, null=True, verbose_name='Дата мягкого удаления')),
                ('editing', models.BooleanField(default=True, verbose_name='Возможность редактирования')),
                ('deliting', models.BooleanField(default=True, verbose_name='Возможность удаления')),
                ('lastmodified', models.DateTimeField(db_index=True, default=django.utils.timezone.now, editable=False, verbose_name='Последнее обновление')),
                ('date', models.DateTimeField(default=None)),
                ('description', models.TextField(blank=True, null=True)),
                ('num', isc_common.fields.code_field.CodeField(blank=True, null=True)),
                ('operation_operation_num', models.PositiveIntegerField()),
                ('production_operation_attrs', ArrayField(base_field=isc_common.fields.code_field.CodeField(blank=True, null=True), size=None)),
                ('value_sum', models.DecimalField(decimal_places=4, max_digits=19)),
                ('value1_sum', models.DecimalField(decimal_places=4, max_digits=19)),
                ('value_made', models.DecimalField(blank=True, decimal_places=4, max_digits=19, null=True)),
                ('value_start', models.DecimalField(blank=True, decimal_places=4, max_digits=19, null=True)),
                ('value_odd', models.DecimalField(decimal_places=4, max_digits=19)),
                ('props', bitfield.models.BitField((('inner_routing', 'Связь операций внутри товарной позиции'), ('outer_routing', 'Связь операций между товарными позициями'), ('product_order_routing', 'Связи в блоке задания на производство'), ('product_making', 'Связи в блоке выпуска'), ('product_releases', 'Связи операций в производства и выпусков - релизов')), db_index=True, default=0)),
            ],
            options={
                'verbose_name': 'Операции Заказа на производство',
                'db_table': 'planing_production_order_opers_per_launch_view',
                'managed': False,
            },
        ),
        migrations.CreateModel(
            name='Production_order_per_launch',
            fields=[
                ('id', models.BigAutoField(primary_key=True, serialize=False, verbose_name='Идентификатор')),
                ('deleted_at', models.DateTimeField(blank=True, db_index=True, null=True, verbose_name='Дата мягкого удаления')),
                ('editing', models.BooleanField(default=True, verbose_name='Возможность редактирования')),
                ('deliting', models.BooleanField(default=True, verbose_name='Возможность удаления')),
                ('lastmodified', models.DateTimeField(db_index=True, default=django.utils.timezone.now, editable=False, verbose_name='Последнее обновление')),
                ('date', models.DateTimeField(default=None)),
                ('isFolder', models.BooleanField(default=None)),
                ('num', isc_common.fields.code_field.CodeField(blank=True, null=True)),
                ('description', models.TextField(blank=True, null=True)),
                ('exucutors', ArrayField(base_field=models.BigIntegerField(), default=list, size=None)),
                ('location_sector_full_name', models.TextField()),
                ('location_sector_id', models.BigIntegerField()),
                ('value_sum', models.DecimalField(decimal_places=4, max_digits=19)),
                ('value1_sum', models.DecimalField(decimal_places=4, max_digits=19)),
                ('value_start', models.DecimalField(blank=True, decimal_places=4, max_digits=19, null=True)),
                ('value_made', models.DecimalField(blank=True, decimal_places=4, max_digits=19, null=True)),
                ('value_odd', models.DecimalField(decimal_places=4, max_digits=19)),
                ('props', bitfield.models.BitField((('inner_routing', 'Связь операций внутри товарной позиции'), ('outer_routing', 'Связь операций между товарными позициями'), ('product_order_routing', 'Связи в блоке задания на производство'), ('product_making', 'Связи в блоке выпуска'), ('product_releases', 'Связи операций в производства и выпусков - релизов')), db_index=True, default=0)),
            ],
            options={
                'verbose_name': 'Заказы на производство',
                'db_table': 'planing_production_order_per_launch_view',
                'managed': False,
            },
        ),
        migrations.AlterField(
            model_name='operation_refs',
            name='props',
            field=bitfield.models.BitField((('inner_routing', 'Связь операций внутри товарной позиции'), ('outer_routing', 'Связь операций между товарными позициями'), ('product_order_routing', 'Связи в блоке задания на производство'), ('product_making', 'Связи в блоке выпуска'), ('product_releases', 'Связи операций в производства и выпусков - релизов')), db_index=True, default=0),
        ),
    ]
